/*---------------------------------------------------------------------------*\
 
    FILE....: dglist.c
    AUTHOR..: Paulo Garcia
    DATE....: 27/02/2004
 
    List cards structures and port numbers

---------------------------------------------------------------------------*/
 
/*-------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#ifdef __LINUX__
	#include <strings.h>
	#include <pthread.h>
	#include <getopt.h>
#else
	#include <string.h>
	#include <conio.h>
	#include <windows.h>
	#define DllImport   __declspec(dllimport)
#endif


#include <vlibdef.h>
#include <voicerlib.h>

#define MAX_PATH 	255
#define MAX_CH		360


void GetCardName(short nCard, char *szCardName)
{
	switch(dg_GetCardType(nCard))
	{
		case VBE13060PCI:
			strcpy(szCardName,"E1 30/60 rev.1\0");
			break;
		case VB0408PCI:
			strcpy(szCardName,"VoicerBox 0408\0");
			break;	
		case VBE13060PCI_R:
			strcpy(szCardName,"E1 30/60 rev.2\0");
			break;
		case VBE16060PCI:
		case VBE16060PCI_R:
			strcpy(szCardName,"E1 60/60 slim\0");
			break;
	}
}

//------------------------------------------------------------------------------------------
// Main Function 
//------------------------------------------------------------------------------------------
int main (int argc, char *argv[])
{
    int ret, i=0;
    short card=0;
    char szCardName[MAX_PATH];
		
	/* Start VoicerLib engine */
	if ((ret = dg_StartVoicerlib(NULL)) != DG_EXIT_SUCCESS)
	{
			printf("\nError starting voicerlib (code %d)\n",ret);
			exit(EXIT_FAILURE);
	}
	printf("\nVoicerlib Started!\n");
	printf("-------------------------------------------------\n");	
	printf("Port   Card   Card/Ch Bus/Slot Name\n");
	printf("-------------------------------------------------\n");

	for (i=1;i<=dg_GetPortsCount(); i++)
	{
		card = dg_GetCardNumber(i);
		GetCardName(card, szCardName);
		printf("%02d      %02d       %02d     %d/%d    %s\n",i,card,dg_GetRelativeChannelNumber(i),
			    dg_GetCardBus(card), dg_GetCardSlot(card),szCardName);
			    
		if ((i%15)==0 && i!=dg_GetPortsCount())
		{
			printf("-------------------------------------------------\n");
			printf("Port   Card   Card/Ch Bus/Slot Name\n");
			printf("-------------------------------------------------\n");
		}
	}
	dg_ShutdownVoicerlib();
	printf("\n(*) Bus/Slot info is only available in Windows (for now)\n");
	printf("\n\n* * * Goodbye! * * *\n\n");
	return DG_EXIT_SUCCESS;
}

